/*#############################################
#
# Title:        mod_but_cookiestore.c
# Author:       e1@but.ch
# Date:         February 10, 2006
# Version:      2.0
#
#############################################*/


#include "mod_but.h"

int find_empty_cookiestore_slot(request_rec *r){

	apr_rmm_t *cs_rmm_cookiestore = find_cs_rmm_cookiestore();
	apr_rmm_off_t *off_cookiestore = find_cs_rmm_off_cookiestore();
	int i;

	for (i = 0; i < MOD_BUT_COOKIESTORE_COUNT; i++) {
        	mod_but_cookie_cookiestore *c = apr_rmm_addr_get(cs_rmm_cookiestore, off_cookiestore[i]);
		if (c->cookie_slot_used == -1) {
			c->cookie_slot_used = 1;
			return i;
		 }
	}

	// if no more shm available
	apr_table_set(r->notes, "CS_SHM" , "PROBLEM");
	return -1;

}

/*
	return 10 = Cookie with same name exist
	return 20 = New Cookiestore slot created

*/
int store_cookie_in_cookiestore(request_rec *r, int anchor, mod_but_cookie_cookiestore *cs){

	apr_rmm_t *cs_rmm_cookiestore = find_cs_rmm_cookiestore();
	apr_rmm_off_t *off_cookiestore = find_cs_rmm_off_cookiestore();

	apr_rmm_t *cs_rmm = find_cs_rmm();
	apr_rmm_off_t *off = find_cs_rmm_off();

	ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: INSIDE OF: store_cookie_in_cookiestore is");


	if(apr_table_get(r->notes, "SHMOFFSET")){
		apr_int64_t i;
		mod_but_cookie *c;
		mod_but_cookie_cookiestore *c1;

		i = apr_atoi64(apr_table_get(r->notes, "SHMOFFSET"));
		ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: GET SHMOFFSET [%d]", (int)i);


		// C is a pointer to the MOD_BUT_SESSION
		c = apr_rmm_addr_get(cs_rmm, off[i]);

		// C1 is the current cookie struct we want to analyze
		c1 = apr_rmm_addr_get(cs_rmm_cookiestore, off_cookiestore[anchor]);


		ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: C: MOD_BUT COOKIE: SESSION NAME = %s", c->session_name);
		ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: C: MOD_BUT COOKIE: SESSION VALUE = %s", c->session_value);
		ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: C1: CURRENT COOKIE STRUCT FOR ANALYZE: COOKIE NAME = %s", c1->cookie_name);
		ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: C1: CURRENT COOKIE STRUCT FOR ANALYZE: COOKIE VALUE = %s", c1->cookie_value);
		ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: CS: COOKIE TO SAVE: COOKIE NAME = %s", cs->cookie_name);
		ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: CS: COOKIE TO SAVE: COOKIE VALUE = %s", cs->cookie_value);


		/* CS is the cookie store struct, we have parsed before. This struct contains the cookies we want to save

		*/
		if (!apr_strnatcmp(cs->cookie_name, c1->cookie_name)){
			/*
				If we are here, a cookie with the same name is found - we just update it's values
			*/
			ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: COOKIESTORE: UPDATE COOKIE [%s]", c1->cookie_name);
			apr_cpystrn(c1->cookie_value, cs->cookie_value, sizeof(c1->cookie_value));
			return 10;
		}else{
			/*
				If we are here, the cookie which will be saved has another name then the current name
			*/
			ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: OUTPUT FILTER: c->cookie_next [%d]", c1->cookie_next);
			if (c1->cookie_next == -1){
				int cookiestore_offset = find_empty_cookiestore_slot(r);
				if (cookiestore_offset >= 0){
					mod_but_cookie_cookiestore *cs2;

					ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: Search empty cookiestore storage %d", cookiestore_offset);
					// C2 is the cookiestore struct, we want to store everything into
					cs2 = apr_rmm_addr_get(cs_rmm_cookiestore, off_cookiestore[cookiestore_offset]);
					ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: COOKIESTORE: Save Cookie in store [%s]", cs->cookie_value);
					apr_cpystrn(cs2->cookie_name, cs->cookie_name, sizeof(cs2->cookie_name));
					apr_cpystrn(cs2->cookie_value, cs->cookie_value, sizeof(cs2->cookie_value));
					ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: C1: Update cookie_next [%d]", c1->cookie_next);
					c1->cookie_next = cookiestore_offset;
					cs2->cookie_next=-1;
					ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: cs2->cookie_next [%d]", cs2->cookie_next);
					if(cs2->cookie_next == -1){
						ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: cs2->cookie_next ist -1");
					}else{
						ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: ======== cs2->cookie_next ist NICHT -1");
					}
					return 20;
				} else {
					ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: CRITICAL ERROR");
					return HTTP_INTERNAL_SERVER_ERROR;
				}

			}else{
				int status;
				ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: cookie next is defined");
				status = store_cookie_in_cookiestore(r, c1->cookie_next, cs);
				return status;
			}
		}
	}
	return 10;
}

void delete_cookiestore_entries_belonging_to_a_deleting_session(request_rec *r, int anchor){

	apr_rmm_t *cs_rmm_cookiestore = find_cs_rmm_cookiestore();
	apr_rmm_off_t *off_cookiestore = find_cs_rmm_off_cookiestore();

	mod_but_cookie_cookiestore *c = apr_rmm_addr_get(cs_rmm_cookiestore, off_cookiestore[anchor]);

	if (c->cookie_next == -1){
		ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: COOKIE STORE: DELETE AT POSITION [%d]", anchor);
		ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: Deleting cookiestore cookiename [%s] and cookievalue [%s]", c->cookie_name, c->cookie_value);
		apr_cpystrn(c->cookie_name, "empty", sizeof(c->cookie_name));
		apr_cpystrn(c->cookie_value, "empty", sizeof(c->cookie_value));
		c->cookie_next = -1;
		c->cookie_slot_used = -1;
	}else{
		int b3;
		ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: COOKIE STORE: DELETE AT POSITION [%d]", anchor);
		b3=c->cookie_next;
		apr_cpystrn(c->cookie_name, "empty", sizeof(c->cookie_name));
		apr_cpystrn(c->cookie_value, "empty", sizeof(c->cookie_value));
		c->cookie_next = -1;
		c->cookie_slot_used = -1;
		delete_cookiestore_entries_belonging_to_a_deleting_session(r, b3);
		ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: Delete HEADER @ CS offset %d", c->cookie_next);
		ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: Deleting cookiestore cookiename [%s] and cookievalue [%s]", c->cookie_name, c->cookie_value);
	}

}

void add_headers_into_request_from_cookiestore(request_rec *r, int anchor){

	apr_rmm_t *cs_rmm_cookiestore = find_cs_rmm_cookiestore();
	apr_rmm_off_t *off_cookiestore = find_cs_rmm_off_cookiestore();

	mod_but_cookie_cookiestore *c = apr_rmm_addr_get(cs_rmm_cookiestore, off_cookiestore[anchor]);
	ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: Analyzing headers from cookie store anchor [%d]", anchor);
	ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: c->cookie_next has: [%d]", c->cookie_next);

	if (c->cookie_next == -1){
		const char *insert_cookie = NULL;
		insert_cookie = (char *)apr_psprintf(r->pool, "%s=%s", c->cookie_name, c->cookie_value);
		ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: insert_cookie [%s]", insert_cookie);
		if (insert_cookie != NULL){
			ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: insert_cookie [%s]", insert_cookie);
			apr_table_addn(r->headers_in, "Cookie", insert_cookie);
		}
		ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: VOR RETURN in add_headers_into_request_from_cookiestore");
		return;
	}else{
		const char *insert_cookie = NULL;
		insert_cookie = (char *)apr_psprintf(r->pool, "%s=%s", c->cookie_name, c->cookie_value);
		ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: insert_cookie [%s]", insert_cookie);
		if (insert_cookie != NULL){
			ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: insert_cookie [%s]", insert_cookie);
			apr_table_addn(r->headers_in, "Cookie", insert_cookie);
		}
		ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r, "mod_but_cookiestore.c: ====== VOR add_headers_into_request_from_cookiestore ====");
		add_headers_into_request_from_cookiestore(r, c->cookie_next);
	}
}



